﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WSUniversalLib
{
    public class Calculation
    {
        /// <summary>
        /// Метот расчета приоритета агента 
        /// </summary>
        /// <param name="agentType"> Тип агента</param>
        /// <param name="age"> Возраст агента</param>
        /// <param name="experience"> Опыт агента</param>
        /// <returns>Новый приоритет агента</returns>
        public int GetPriorityForAgent(int agentType, float age, float experience)
        {
            if (agentType<= 0 || age <= 0 || experience<=0 )
            {
                return - 1;
            }

                double coeff;
                if (agentType == 1 && age < 26 && experience < 4)
                {
                    coeff = 1.8 + 0.1;
                }
                else if (agentType == 2 && age < 26 && experience < 4)
                {
                    coeff = 3.2 + 0.17;
                }
                else if (agentType == 3 && age < 26 && experience < 4)
                {
                    coeff = 4.1 + 0.26;
                }
                else if (agentType == 1 && age > 26 && experience > 4)
                {
                    coeff = 1.8;
                }
                else if (agentType == 2 && age > 26 && experience > 4)
                {
                    coeff = 3.2;
                }
                else if (agentType == 3 && age > 26 && experience > 4)
                {
                    coeff = 4.1;
                }
                else
                {
                    return -1;
                }


                if (experience > 11)
                {
                    coeff += 0.5;
                }
                else if (experience > 21)
                {
                    coeff += 0.7;
                }
                else if (experience > 41)
                {
                    coeff += 0.9;
                }

                int NewPriority = Convert.ToInt32(Math.Round(experience * coeff));
                return NewPriority;
            }

        }
    }
  
    

